unit uvates;

{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, Grids,
  ucosa, ucosaConNombre,
  usalasdejuego,
  utrazosxy,
  uestados, uversiones, uInicioYFinal,
  xmatdefs, Math,
  uglobs,
  umipsimplex_mejorcamino,
  upronostico,
  uNodos,
  uHidroConEmbalse, uFuenteSintetizador, uactores, uacumuladores_sim,
  uauxiliares,
  ugraficador,
  uregistradorVates,
  uDemandaConRespuesta, ueditorPanelG, uRobotHttpPost;



type

  { TVatesForm }

  TVatesForm = class(TForm)
    btCargarSala: TButton;
    btSimularTramo: TButton;
    Button1: TButton;
    btCrearDCR: TButton;
    cbConvergio: TCheckBox;
    cbMaxIter_TRI: TCheckBox;
    cbObligarDisponibilidad_1_Sim: TCheckBox;
    cbObligarInicioCronicaIncierto_1_sim: TCheckBox;
    cbPausaPorIter: TCheckBox;
    cbImponerCMGConstante: TCheckBox;
    eArchiSala: TEdit;
    eMaxNItersSim: TLabeledEdit;
    eNCronicasSim: TLabeledEdit;
    eSemillaAleatoriaSim: TLabeledEdit;
    e_cntIter_TRI: TLabeledEdit;
    e_err2cmg: TLabeledEdit;
    e_kPaso_Vates: TLabeledEdit;
    e_Peso_Ant: TLabeledEdit;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    OpenDialog1: TOpenDialog;
    PageControl1: TPageControl;
    Panel4: TPanel;
    pbx0: TPaintBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Panel3: TPanel;
    Panel_G0: TPanel;
    Panel_G1: TPanel;
    Panel_G4: TPanel;
    Panel_G2: TPanel;
    Panel_G5: TPanel;
    Panel_G3: TPanel;
    Panel_G6: TPanel;
    pbx1: TPaintBox;
    pbx2: TPaintBox;
    pbx3: TPaintBox;
    pbx4: TPaintBox;
    pbx5: TPaintBox;
    pbx6: TPaintBox;
    separador_V1: TSplitter;
    separador_V2: TSplitter;
    separador_H1: TSplitter;
    separador_H2: TSplitter;
    separador_H3: TSplitter;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    procedure btCargarSalaClick(Sender: TObject);
    procedure btCrearDCRClick(Sender: TObject);
    procedure btSimularTramoClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure cbImponerCMGConstanteChange(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure pbx1Paint(Sender: TObject);
  private
    { private declarations }

  public
    { public declarations }
    procedure RedimensionarPaneles;

  end;


var
  VatesForm: TVatesForm;
  sala: TSalaDeJuego;
  dtInicioVates: TDateTime;
  kPasoVates, NPasosVates: integer;
  cntIter_TRI: integer;
  NCronicas: integer;
  NHorasTramo: integer;
  cmg_VE_ant, cmg_PE10_ant, cmg_PE90_ant, cmg_HOraAnt: TDAOfNReal;
  DCR_MW_ant, DCR_MW: TDAOfNReal;
  xdt: TDAOfNReal;

  aNodo_TRI: TNodo;
  aCEGH_fDCR: TFuenteSintetizadorCEGH;
  aguia_fDCR: TDAOfNReal;

  aHidroBon, aHidroPal, aHidroSG: THidroConEmbalse;
  aCEGH_Eol1MW: TFuenteSintetizadorCEGH;


  err2_cmg: NReal;
  flg_Convergio: boolean;
  flg_MaxIter_TRI: boolean;
  MAX_ERR2_CMG: NReal;
  MAX_CNTITER_TRI: integer;
  peso_ant: NReal;
  regVates_cmg: TRegistroVates;

  panelesG: TRecGraficosLst;

  recSeriesLst: TRecSeriesLst;

  flg_unlock: boolean;
  flg_Corriendo: boolean;
  flg_Terminar: boolean;
  aSerieX: TSerie; // tiene el eje del tiempo

  sal_vates: TextFile;
  flg_iniciando_cmg_HoraAnt: boolean;
  Calefones, Autos: TPoblacion;
  hBon_, hPal_, hSG_: NReal;
  eol1MW_: NReal;
  x_sig: NReal;

  kCronicaEvolucionVates: integer;
  ars_cmg, ars_cdp, ars_cf, ars_hBon, ars_hPal, ars_hSG,
  ars_eolP, ars_eol1MW, ars_DemP, ars_FDCR, ars_Exp: TRecSerie;



procedure Prepararse(Sala: TSalaDeJuego; idHilo: integer);

function Simular_Intervalo(Sala: TSalaDeJuego; idHilo: integer;
  print: boolean; cntIter_TRI: integer): NReal;




implementation

{$R *.lfm}


{ TVatesForm }

procedure TVatesForm.btCargarSalaClick(Sender: TObject);
var
  k: integer;
  aSerie : TSerie;
  aGrafico: TGrafico;
  aPanel: TPaintBox;
  lst: TListaDeCosasConNombre;

begin
//  eArchiSala.Text := 'C:\simsee\SimSEE_src\src\trunk\ap\vates\Sala_Test\vates2018.ese';
  if not OpenDialog1.Execute then exit;

  eArchiSala.Text := OpenDialog1.FileName;
  sala := TSalaDeJuego.cargarSala(eArchiSala.Text, 'CON_DCR', True);
  chdir(sala.dirSala);
  dtInicioVates := sala.globs.fechaIniSim.dt;
  NPasosVates := trunc((sala.globs.fechaFinSim.dt - dtInicioVates) * 24 - 72 + 1);

  kPasoVates := 0;
  MAX_ERR2_CMG :=10;
  MAX_CNTITER_TRI := 10;
  peso_ant := 0.5;



  e_Peso_Ant.text:= FloatToStr( peso_ant );

  //  end;

  self.Caption := 'SimSEE ' + eArchiSala.Text;
  ENCronicasSim.Text := IntToStr(sala.globs.NCronicasSim);

  cbObligarDisponibilidad_1_Sim.Checked := sala.globs.ObligarDisponibilidad_1_Sim;
  cbObligarInicioCronicaIncierto_1_sim.Checked :=
    sala.globs.ObligarInicioCronicaIncierto_1_Sim;
  eMaxNItersSim.Text := IntToStr(sala.globs.NMAX_ITERACIONESDELPASO_SIM);
  eSemillaAleatoriaSim.Text := IntToStr(sala.globs.semilla_inicial_sim);

  NCronicas := 100;
  NHorasTramo := 72;
  sala.globs.NCronicasSim := NCronicas;
  sala.globs.fechaFinSim.dt := sala.globs.fechaIniSim.dt + NHorasTramo * 1 / 24.0;
  sala.globs.NPasos := sala.globs.calcNPasosSim;

  if sala.globs.NPasos <> nHorasTramo then
    raise Exception.Create(
      'Error, Por alguna razón sala.globs.NPasos <> nHorasTramo - REVISAR');

  Prepararse(sala, 0);

  setlength(cmg_VE_ant, NHorasTramo);
  setlength(cmg_PE10_ant, NHorasTramo);
  setlength(cmg_PE90_ant, NHorasTramo);
  setlength(DCR_MW_ant, NHorasTramo);
  setlength(DCR_MW, NHorasTramo);
  setlength(xdt, NHorasTramo);
  setlength(cmg_HOraAnt, NHorasTramo);


  sala.globs.CF := TAdminEstados_SobreMuestreado.CreateLoadFromArchi(
//      'C:\simsee\SimSEE_src\src\trunk\ap\vates\Sala_Test\CF_SIN_DCR.bin'
        'C:\simsee\corridas_2015\Vates_Sala_Test\CF_SIN_DCR.bin'
      , sala.globs.fechaIniSim.dt, sala.globs.fechaFinSim.dt,
    sala.globs.HorasDelPaso);

(*
  sala.globs.CF := TAdminEstados_SobreMuestreado.CreateLoadFromArchi(
    sala.dirResultadosCorrida + 'CFBase_' + sala.EscenarioActivo.nombre +
    '.bin', sala.globs.fechaIniSim.dt, sala.globs.fechaFinSim.dt,
    sala.globs.HorasDelPaso);
  *)

  aCEGH_Eol1MW := sala.BuscarPorNombre('eol1MW', lst) as TFuenteSintetizadorCEGH;
  aHidroBon := sala.BuscarPorNombre('Bonete', lst) as THidroConEmbalse;
  aHidroPal := sala.BuscarPorNombre('Palmar', lst) as THidroConEmbalse;
  aHidroSG := sala.BuscarPorNombre('SG', lst) as THidroConEmbalse;
  aCEGH_fDCR := sala.BuscarPorNombre('fDCR', lst) as TFuenteSintetizadorCEGH;
  aNodo_TRI := sala.BuscarPorNombre('NodoGen', lst) as TNodo;



  //  aSerie:= TSerie.Create( 'fecha', xdt, nil, nil, 'DD/MM/AAA hh', true );
  aSerieX := TSerie.Create('fecha', xdt, nil, nil, '', True);
  for k := 0 to high(xdt) do
    xdt[k] := k; //sala.globs.fechaIniSim.dt + k * 1.0/24.0;


  panelesG := TRecGraficosLst.Create( Self, 7, aSerieX );

  recSeriesLst:= TRecSeriesLst.Create( panelesG );

  // Agregamos al registradorVates lo necesario.
  uregistradorVates.MuestrarAlFinDeCadaPasoSimOnSala(sala );
  ars_cmg:= recSeriesLst.AddRec(0, 'NodoGen', 'cmg_P1', 'cmg' );
  regVates_cmg:= ars_cmg.registroVates;

  recSeriesLst.AddRec( 0, '', '', 'cmg_ant', cmg_VE_ant  );
  recSeriesLst.AddRec( 0, '', '', 'DCR_MW', DCR_MW, 1  );
  recSeriesLst.AddRec( 0, '', '', 'DCR_MW_ant', DCR_MW_ant, 1  );

  // Agregados a mano por ahora
  // Panel 1
  ars_DemP:= recSeriesLst.AddRec(2, 'Demanda', 'PD_P1', 'Demanda' );
  ars_Exp:= recSeriesLst.AddRec(2, 'Exportacion', 'P_P1', 'Exp_7USD/MWh' );
  ars_fDCR:= recSeriesLst.AddRec(3, 'fDCR', 'Borne[4]', 'fDCR' );
  recSeriesLst.AddRec(2, '', '', 'cmg_VE', regVates_cmg.serie_VE, 1 );
  recSeriesLst.AddRec(2, '', '', 'cmg_PEa', regVates_cmg.serie_PEa, 1 );
  recSeriesLst.AddRec(2, '', '', 'cmg_PEb', regVates_cmg.serie_PEb, 1 );

  ars_hBon:= recSeriesLst.AddRec(5, 'Bonete', 'h', 'hBon' );
  ars_hPal:= recSeriesLst.AddRec(5, 'Palmar', 'h', 'hPal' );
  ars_hSG:= recSeriesLst.AddRec(5, 'SG', 'h', 'hSG' );

  ars_cf:=  recSeriesLst.AddRec(4, '-', 'CF_AlInicioDelPaso', 'CF_InicioDelPaso', nil, 0 );
  ars_cdp:=  recSeriesLst.AddRec(4, '-', 'CPDirecto', 'CPDirecto', nil, 0 );
  ars_eolP:= recSeriesLst.AddRec(6, 'Eolica', 'P_P1', 'Eolica_MW' );
  ars_eol1MW:= recSeriesLst.AddRec(4, 'eol1MW', 'Borne[4]', 'eol1MW', nil, 1 );


  // Ponemos un valor inicial de 100 USD/MWh como costos marginales
  for k := 0 to regVates_cmg.NPuntosT - 1 do
  begin
    cmg_VE_ant[k] := 100;
    cmg_PE10_ant[k] := 100;
    cmg_PE90_ant[k] := 100;
    regVates_cmg.serie_VE[k] := 100;
    regVates_cmg.serie_PEa[k] := 100;
    regVates_cmg.serie_PEb[k] := 100;
    cmg_HoraAnt[k]:= 100;
  end;

  cntIter_TRI := 0;
  flg_iniciando_cmg_HoraAnt:= true;

end;

procedure TVatesForm.btCrearDCRClick(Sender: TObject);
begin
  calefones:= uDemandaConRespuesta.CrearCalefones( 100{u}, 18{h}, 23{h}, 60{lt}, 1.5{kW}, 0.98, NHorasTramo );
 Autos:= uDemandaConRespuesta.CrearFlotaAutosElectricos( 40{u}, 7, 20, 15, 1.8, 1.8, 0.98, NHorasTramo );


  if Calefones <> nil then
    recSeriesLst.AddRec(5, '', '', 'ECalefones', Calefones.Energias );

  if Autos <> nil then
    recSeriesLst.AddRec(5, '', '', 'EAutos', Autos.Energias );

end;


procedure TVatesForm.btSimularTramoClick(Sender: TObject);

var
  guia: TDAOfNReal;
  k: integer;
  aProno: TPronostico;
  VE_CT: NReal;
  Nodo_TRI: TNodo;
  a: TDAofNReal;
  hora: integer;
  rbthttp: TRobotHttpPost;
  res: TStringList;
  rs: string;
  dem_MW: NReal;
  eol_MW: NReal;
  alfa: NReal;

  sal_DCR: textfile;

begin


  assignfile( sal_DCR, 'c:\basura\dcr.xlt' );
  rewrite( sal_DCR );
  writelN( sal_DCR, 'Inicio: ', DateTimeToStr( now ) );

  assignfile( sal_vates, 'c:\basura\sal_vates_'+ IntToStr( kCronicaEvolucionVates )+'.xlt' );
  rewrite( sal_vates );
  writelN( sal_vates, 'Inicio: ', DateTimeToStr( now ), #9, 'kCronicaVates:', #9, kCronicaEvolucionVates  );
  writeln( sal_vates, 'kPaso', #9, 'dt', #9, 'hBon',
   #9, 'hPal',
   #9, 'hSG',
   #9, 'EolMW',
   #9, 'cmg',
   #9, 'cdp',
   #9, 'cf',
   #9, 'Dem_MW',
   #9, 'DCR_MW',
   #9, 'Exp_MW'
  );

  peso_ant:= StrToFloat( e_Peso_Ant.text );
  kPasoVates := 0;
  flg_Terminar := False;
  flg_Corriendo := True;


  while (kPasoVates < NPasosVates) and (not flg_Terminar) do
  begin
    sala.globs.fechaIniSim.dt := kPasoVates * 1 / 24.0 + dtInicioVates;
    sala.globs.fechaFinSim.dt := sala.globs.fechaIniSim.dt + NHorasTramo * 1 / 24.0;
    sala.globs.NPasos := sala.globs.calcNPasosSim;

    hora:= trunc( sala.globs.fechaIniSim.dt * 24 ) mod 24;
    for k:= 0 to high( aSerieX.valores) do
      aSerieX.valores[k]:= hora+k;

    panelesG.cambiar_eje_x( 'hora comenzando el: '+DateTimeToStr( sala.globs.fechaIniSim.dt ), hora, hora+high( aSerieX.valores) );

// LECTURA DEL ESTADO DEL SISTEMA. (cotas)
(**
    rbthttp:= TRobotHttpPost.Create( 'http://simsee.org/pronosticos/cotas.php', '+inicio',  '+fin' );
    rbthttp.AddCampo('dtIniSim', sala.globs.fechaIniSim.AsISOStr );
    rbthttp.AddCampo('kPasoVates', IntToStr( kPasoVates ) );
    res:= rbthttp.post('GET');
    rs:= res[2];
    rbthttp.Free;
    **)

    rs:= FloatToStr( hBon_ )+' '+FloatToStr( hPal_ )+' '+FloatToStr( hSG_ );
    aHidroBon.hini := NextFloat( rs ); //74.5;
    aHidroPal.hini := NExtFloat( rs ); //38.5;
    aHidroSG.hini := NextFloat( rs ); //33.61;

// LECTURA DEL PRONISTICO DE GENERACION ERNC.
    guia := aCEGH_Eol1MW.pronosticos.items[0].guia;
    rbthttp:= TRobotHttpPost.Create( 'http://simsee.org/pronosticos/index.php', '+inicio',  '+fin' );
    rbthttp.AddCampo('dtIniSim', FloatToStr( sala.globs.fechaIniSim.AsDt ) );
    rbthttp.AddCampo('x', FloatToStr( x_sig ) );
    res:= rbthttp.post('GET');
    rbthttp.Free;

    rs:= res[0];
    nextpal( rs ); // xsig:
    x_sig:= nextFloat( rs );


    for k:= 0 to 71 do
    begin
      rs:= res[k+3];
      hora:= nextInt( rs );
      dem_MW:= nextFloat( rs );
      EOL_MW:= nextFloat( rs );
      if kPasoVates = 0 then
        guia[k]:=  EOL_MW/600.0
      else
        if k < 71 then
         guia[k]:= guia[k+1]*0.9+  EOL_MW/600.0 * 0.1
        else
         guia[k]:= guia[k]*0.9+  EOL_MW/600.0 * 0.1
    end;


(*
    guia[0] := random();
    for k := 1 to high(guia) do
      guia[k] := min(0.9 * guia[k - 1] + 0.099 * random(), 1);
  *)

    aCEGH_EOL1MW.recalibrarPronosticos(sala.globs.FechaIniSim);

    aProno := aCEGH_fDCR.pronosticos.items[0];
    aProno.NPCC := NHorasTramo;
    aProno.NPLC := 0;
    aProno.NPSA := NHorasTramo;
    aProno.NPAC := 0;

    // esta no es necesaria
    aguia_fDCR := aProno.guia;
    for k := 0 to high(aguia_fDCR) do
      aguia_fDCR[k] := DCR_MW[k mod NHorasTramo];
    aCEGH_fDCR.recalibrarPronosticos(sala.globs.FechaIniSim);


    // Inicio nueva iteración.
    cntIter_TRI := 0;

    flg_Convergio := False;
    flg_MaxIter_TRI := False;
    e_cntIter_TRI.Text := '0';
    cbConvergio.Checked := flg_Convergio;
    cbMaxIter_TRI.Checked := flg_MaxIter_TRI;
    e_err2cmg.Text := FloatToStr(err2_cmg);

    panelesG.draw;

    repeat
      flg_unlock := not cbPausaPorIter.Checked;
      while not flg_unlock do
        application.ProcessMessages;

      e_kPaso_Vates.Text := IntToStr(kPasoVates);

      if cntIter_TRI > 0 then
        for k := 0 to regVates_cmg.NPuntosT - 1 do
        begin
          regVates_cmg.serie_VE[k] :=
            cmg_VE_ant[k] * peso_ant + regVates_cmg.serie_VE[k] * (1 - peso_ant);
          regVates_cmg.serie_PEa[k] :=
            cmg_PE10_ant[k] * peso_ant + regVates_cmg.serie_PEa[k] * (1 - peso_ant);
          regVates_cmg.serie_PEb[k] :=
            cmg_PE90_ant[k] * peso_ant + regVates_cmg.serie_PEb[k] * (1 - peso_ant);
        end;
   (**

      for k := 0 to regVates_cmg.NPuntosT - 1 do
      begin
         regVates_cmg.serie_VE[k]:= 20 + 140/72*k;
         cmg_HoraAnt[k]:= 20 + 140/72*k;
      end;
      **)

      // Aquí llamamos al simulador de Demanda Con Respuesta SimDCR
      CDR_MW(DCR_MW,
        cmg_HoraAnt,
        regVates_cmg.serie_VE,
        sala.globs.fechaIniSim.dt,
        cbImponerCMGConstante.Checked );



      // mmm bueno le pongo este AMORTIGUADOR a la demanda para que no eloquesca
      if cntIter_TRI > 0 then
         for k := 0 to regVates_cmg.NPuntosT - 1 do
             DCR_MW[k] := DCR_MW_ant[k] * peso_ant+ DCR_MW[k] * (1 - peso_ant);

      // Actualizamos la fuente de Demanda Con Respuesta
      for k := 0 to high(aguia_fDCR) do
        aguia_fDCR[k] := DCR_MW[k mod NHorasTramo];
      aCEGH_fDCR.recalibrarPronosticos(sala.globs.FechaIniSim);


      VE_CT := Simular_Intervalo(sala, 0, False, cntIter_TRI);
      Inc(cntIter_TRI);
      e_cntIter_TRI.Text := IntToStr(cntIter_TRI);

      err2_cmg := 0;

      uRegistradorVates.Resumir;

      for k := 0 to regVates_cmg.NPuntosT - 1 do
        err2_cmg := err2_cmg + sqr(regVates_cmg.Serie_VE[k] - cmg_VE_ant[k]);

      panelesG.draw;

      if flg_Iniciando_cmg_HoraANt then
      begin
        for k:= 0 to high( regVates_cmg.serie_VE ) do
              cmg_HoraAnt[k]:= regVates_cmg.serie_VE[k];
        flg_iniciando_cmg_HoraAnt:= false;
      end;


      vCopySwap(regVates_cmg.serie_VE, cmg_VE_ant);
      vCopySwap(regVates_cmg.serie_PEa, cmg_PE10_ant);
      vCopySwap(regVates_cmg.serie_PEb, cmg_PE90_ant);
      vCopySwap(DCR_MW_ant, DCR_MW);

      flg_Convergio := err2_cmg < MAX_ERR2_CMG;
      flg_MaxIter_TRI := cntIter_TRI > MAX_CNTITER_TRI;

      cbConvergio.Checked := flg_Convergio;
      cbMaxIter_TRI.Checked := flg_MaxIter_TRI;
      e_err2cmg.Text := FloatToStr(err2_cmg);

      Application.ProcessMessages;
    until flg_Convergio or flg_MaxIter_TRI or flg_Terminar;

    write( sal_DCR, kPasoVates );

    for k:= 0 to high( DCR_MW ) do
      write( sal_DCR, #9, DCR_MW[k] );
    writeln( sal_DCR );

    hBon_:= ars_hBon.registroVates.GetVal( 1, kCronicaEvolucionVates );
    hPal_:= ars_hPal.registroVates.GetVal( 1, kCronicaEvolucionVates );
    hSG_:= ars_hSG.registroVates.GetVal( 1, kCronicaEvolucionVates );
    eol1MW_:= ars_eol1MW.registroVates.GetVal( 1, kCronicaEvolucionVates );

    write( sal_vates, kPasoVates,#9, sala.globs.fechaIniSim.AsStr );
    writeln( sal_vates,
     #9, hBon_,
     #9, hPal_,
     #9, hSG_,
     #9, ars_eolP.registroVates.GetVal(1, kCronicaEvolucionVates ),
     #9, regVates_cmg.GetVal( 1, kCronicaEvolucionVates ),
     #9, ars_cdp.registroVates.GetVal( 1, kCronicaEvolucionVates ),
     #9, ars_cf.registroVates.GetVal(1, kCronicaEvolucionVates ),
     #9, ars_DemP.registroVates.GetVal( 1, kCronicaEvolucionVates ),
     #9, ars_FDCR.registroVates.GetVal( 1, kCronicaEvolucionVates )*1000,
     #9, ars_Exp.registroVates.GetVal( 1, kCronicaEvolucionVates )
    );



    Inc(kPasoVates);


    // como valores iniciales hacemos un shift de los valores
    // del paso anterior
    for k := 1 to regVates_cmg.NPuntosT - 1 do
    begin
      cmg_VE_ant[k - 1] := cmg_VE_ant[k];
      cmg_PE10_ant[k - 1] := cmg_PE10_ant[k];
      cmg_PE90_ant[k - 1] := cmg_PE90_ant[k];
      regVates_cmg.serie_VE[k - 1] := regVates_cmg.serie_VE[k];
      regVates_cmg.serie_PEa[k - 1] := regVates_cmg.serie_PEa[k];
      regVates_cmg.serie_PEb[k - 1] := regVates_cmg.serie_PEb[k];
      DCR_MW[k - 1] := DCR_MW[k];
      DCR_MW_ant[k - 1] := DCR_MW_ant[k];
    end;
    for k:= 0 to high( regVates_cmg.serie_VE ) do
      cmg_HoraAnt[k]:= regVates_cmg.serie_VE[k];
  end;
  closefile( sal_DCR );
  closefile( sal_vates );
  flg_Corriendo:= false;
  if flg_terminar then Close;
end;

procedure TVatesForm.Button1Click(Sender: TObject);
begin
  flg_unlock := True;
end;

procedure TVatesForm.cbImponerCMGConstanteChange(Sender: TObject);
begin

end;


procedure TVatesForm.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  uInicioYFinal.AlFinal;
end;

procedure TVatesForm.FormCloseQuery(Sender: TObject; var CanClose: boolean);
begin
  flg_Terminar := True;
  CanClose := not flg_Corriendo;
end;



procedure TVatesForm.FormCreate(Sender: TObject);
begin
  self.Caption := 'Vates (c)Proyecto ANII-FSE-1-2011-1-6552  (IIE-FING-UDELAR-FJR) (VER_'
    + uversiones.vSimSEESimulador_ + ')';
  uInicioYFinal.AlInicio;
end;

procedure TVatesForm.FormResize(Sender: TObject);
begin
  RedimensionarPaneles;
end;


procedure TVatesForm.RedimensionarPaneles;
begin
  panel_G1.Height:= height div 2;
  panel_G2.Height:= height div 2;
  panel_G3.Height:= height div 2;
  panel1.width:= width div 3;
  panel2.width:= width div 3;
end;
procedure TVatesForm.FormShow(Sender: TObject);
begin
  RedimensionarPaneles;
end;

procedure TVatesForm.pbx1Paint(Sender: TObject);
begin
  if panelesG <> nil then
    panelesG.draw_panel(Sender as TPaintBox);
end;




procedure Prepararse(Sala: TSalaDeJuego; idHilo: integer);

begin
  sala.globs.EstadoDeLaSala := CES_SIMULANDO;


  // solo para que esté definido.
  sala.spx := TMipSimplex.Create_init(1, 1, 1, sala.getNombreVar, sala.getNombreRes);

  // Preparamos la sala y los actores.
  sala.PrepararMemoriaYListados;
  sala.PrepararActualizadorFichasLPD(True);

  //Publicamos las variables
  sala.publicarTodasLasVariables;

  // Determinamos la dimesión del espacio de estados y si es necesario
  // crear frames auxiliares del estado para cálculos iterativos.
  sala.optx_nvxs;

  sala.Armar_lst_BarridoFijarEstadoDeActoresYFuentesToEstrella;
  sala.Armar_lst_Sim_Paso_Fin;
  sala.Armar_lst_CalcularGradienteDeInversion;

  sala.Armar_lst_EvolucionarEstado;
  sala.Armar_lst_necesitoIterar;

  sala.Armar_lst_Sim_cronicaIdInicio;
end;


function Simular_Intervalo(sala: TSalaDeJuego; idHilo: integer;
  print: boolean; cntIter_TRI: integer): NReal;
var
  costoAcumCronica: NReal;
  utilidadAcumCronica: NReal;
  qAct: NReal;
  idCronicaInicioFuenteK: string;

  CostoAcumVaR95: NReal;
  jCronica: integer;
  CF_AlFinalDeLaCronica: NReal;
  VE_CF: NReal;
  flg_EnGuardaSim: boolean;

begin
  // ACA COMIENZA LA SIM
  sala.Acumuladores := TAcumuladores_Sim.Create(sala.globs, sala.globs.NCronicasSim);
  sala.globs.procNot(sala.globs.procNot_InicioSimulacion);
  sala.globs.kCronica := 1;

  while (sala.globs.kCronica <= sala.globs.NCronicasSim) and
    (not sala.globs.abortarSim)
    and ( not flg_Terminar ) do
  begin

    sala.Sim_Cronica_Inicio;
    // inicializamos los acumuladore de costo y utilidad de la crónica
    costoAcumCronica := 0;
    utilidadAcumCronica := 0;
    qAct := 1;

    // Si corresponde activamos la Guarda de Simulación
    flg_EnGuardaSim := sala.globs.fechaGuardaSim.EsMayorQue(
      sala.globs.fechaIniSim) = 1;

    while (sala.globs.kPaso_ <= sala.globs.nPasos)
      and (not sala.globs.abortarSim)
      and (not flg_terminar ) do
    begin
      sala.globs.procNot(sala.globs.procNot_InicioPaso);

      // si está activada la GuardaSim, nos fijamos si corresponde desactivarla
      if flg_EnGuardaSim then
        flg_EnGuardaSim := sala.globs.fechaGuardaSim.EsMayorQue(
          sala.globs.FechaInicioDelpaso) = 1;

      // Actualiza los parámemtros dinámicos de todos los Entes (Actores, Fuentes, etc.)
      sala.globs.ActualizadorLPD.ActualizarFichasHasta(sala.globs.FechaInicioDelpaso);

      // EVENTO: PrepararPaso_as
      //    Actores + Flucar antes de sorteos
      sala.PrepararPaso_as;

      // EVENTO: SorteosDelPaso( true )
      //    Fuentes (sorteo y calcula bornes calculados) + Actores
      sala.SorteosDelPasoSim(True);


      if sala.globs.CF <> nil then
         begin
           sala.fuentes_ActualizarEstadoGlobal(False);
           sala.actores_ActualizarEstadoGlobal(False);
           sala.CF_AlInicioDelPaso := sala.globs.CF.costoContinuo(sala.globs.kPaso_);
         end;



      // EVENTO: Las Fuentes se preparan PostSorteos para dar el paso.
      //         Por eficiencia esto se hace fuera del bucle de iteraciones del paso
      //         pues se supone que las fuentes no necesitar ITERAR.
      sala.Fuentes_PrepararPaso_ps;

      // EVENTO: Los Actores y las Fuentes PROYECTAN su estado (Xs) al final del paso
      //         lo que da mejor informaicón para el calculo del gradiente de CF al final
      //         del paso que suponer que el estado permanecía fijo. Este cambio es fundamental
      //         para el funcionamiento del vector de deciciones de compras/desvíos de la Regasificadora
      sala.fuentes_ActualizarEstadoGlobal(True);
      sala.actores_ActualizarEstadoGlobal(True);




      // EVENTOs: Actores_PrepararPaso_ps_pre y Actores_PrepararPaso_ps
      //         En esta llamada, si se está usando el método de cálculo
      //         de demanda NETA, se realiza el cálculo de la demanda NETA
      //         y el POSTIZADO efectivo del paso de tiempo. Como consecuencia
      //         se llama al EVENTO: PrepararPaso_ps_pre de los Actores.
      //         Luego se llama al EVENTO: PreaparaPaso_ps de Actores y FLUCAR
      //         Los Actores se preparan PostSorteos para dar el paso.
      //         En esta preparación, cada Actor, calcula los parámetros
      //         dependientes de los valores de las fuentes, los sorteos y
      //         del estado del sistema de su modelo.
      //         Además de los Actores, también se prepara el Iterador
      //         FLUCAR si es que se está usando.
      sala.Actores_PrepararPaso_ps_pre;
      sala.globs.cntIteracionesDelPaso := 0;
      repeat
        Inc(sala.globs.cntIteracionesDelPaso);
        sala.Actores_PrepararPaso_ps;
        sala.CostoDelPaso_spx := sala.ResolverPaso;
      until (sala.globs.cntIteracionesDelPaso >=
          sala.globs.NMAX_ITERACIONESDELPASO_SIM) or (not sala.NecesitoIterar) or flg_Terminar;
      // El bucle de iteraciones se repite hasta alcanzar el número máximo
      // especificado o hasta que ningún Actor ni el Iterador FLUCAR
      // indica que necesita iterar.
      sala.Sim_Paso_Fin;

      application.ProcessMessages;

      sala.CalcularGradientesDeInversion;


      sala.EvolucionarEstado;

      sala.globs.Fijar_kPaso(sala.globs.kPaso_ + 1);

      if not flg_EnGuardaSim then
      begin
        costoAcumCronica := costoAcumCronica + sala.costoDirectoDelPaso * qAct;
        utilidadAcumCronica :=
          utilidadAcumCronica + sala.utilidadDirectaDelPaso * qAct;
        qAct := qAct * sala.globs.fActPaso;
      end;
    end;

    (*** ahora guardo el resultado de la crónica y le sumo el CF_AlFinal de la misma **)
    if sala.globs.CF <> nil then
    begin
      sala.fuentes_ActualizarEstadoGlobal(False);
      sala.actores_ActualizarEstadoGlobal(False);
      CF_AlFinalDeLaCronica := sala.globs.CF.costoContinuo(sala.globs.kPaso_);
    end
    else
      CF_AlFinalDeLaCronica := 0;

    sala.Acumuladores.cdpAcum[sala.globs.kcronica - 1] := costoAcumCronica;
    sala.Acumuladores.udpAcum[sala.globs.kcronica - 1] := utilidadAcumCronica;

    sala.Acumuladores.CF_final[sala.globs.kcronica - 1] :=
      qAct * CF_AlFinalDeLaCronica;

    sala.Acumuladores.costosAcum[sala.globs.kcronica - 1] :=
      costoAcumCronica + sala.Acumuladores.CF_final[sala.globs.kcronica - 1];

    sala.Sim_Cronica_Fin; // entre otras cosas incrementa globs.kCronica

  end;


  sala.FinSimulacion;
  sala.globs.EstadoDeLaSala := CES_SIMULACION_TERMINADA;

  if print then
  begin
    VE_CF := sala.Acumuladores.PrinArchi(sala.dirResultadosCorrida +
      'simcosto_' + 'vt' + sala.globs.fechaFinSim.AsAAAAMMDDhhmmtr +
      IntToStr(cntIter_TRI) + '_' + IntToStr(sala.globs.semilla_inicial_sim) +
      'x' + IntToStr(sala.Globs.NCronicasSim) + '_' +
      sala.EscenarioActivo.nombre + '.xlt');
  end
  else
    VE_CF := sala.Acumuladores.VE_CF_MUSD;

  sala.Acumuladores.Free;

  if sala.globs.EstadoDeLaSala <> CES_SIMULACION_TERMINADA then
    sala.globs.EstadoDeLaSala := CES_SIMULACION_ABORTADA;

  Result := VE_CF;
end;

initialization
  panelesG := nil;
  flg_Terminar := True;
  flg_Corriendo := False;
  Autos:= nil;
  Calefones:= nil;
  hBon_:= 74.5;
  hPal_:= 38.5;
  hSG_:= 33.61;
  eol1MW_:= 0.4;
  kCronicaEvolucionVates:= 8;


end.
