unit uglobs;

interface

uses
  //comctrls,

  xmatdefs, SysUtils, ucosaConNombre, uActualizadorLPD, ufechas,
  uauxiliares,
  uEstados,
  uCosa,
  uConversions,
  Math,
  uconstantesSimSEE,
  umadresuniformes,
  Classes,
  uescenarios;

type

  // hasta que  se implemente un calendario, los Domingos son feriados
  // los sbados son semi-feriados y el resto son hbiles
  TTipoDeDia = (DIA_HABIL, DIA_SEMI_FERIADO, DIA_FERIADO);

  TProcNotificacion = procedure;
  TProcAlerta = procedure(const s: string);

  TEstadoDeLaSala = (
    CES_SIN_PREPARAR,
    CES_OPTIMIZANDO,
    CES_OPTIMIZACION_TERMINADA,
    CES_OPTIMIZACION_ABORTADA,
    CES_SIMULANDO,
    CES_SIMULACION_TERMINADA,
    CES_SIMULACION_ABORTADA);


  { TGlobs }

  TGlobs = class(TCosaConNombre)
  private

    procAlertaHabilitado: boolean;
    procAlerta: TProcAlerta;

    fechaIni_old, fechaFin_old: TFecha;

    demandaPrincipal: TCosa; // actor principal de demanda ESTE POSTIZA

  public

    DurPos: TDAOfNReal;
    {Si est a TRUE se agregan en la salida la generacin de los LowCostMustRun
     y de los NO_LowCostMustRun y la generacin de toneladas de CO2
     de cada Grupo. }
    Calcular_EmisionesCO2: boolean;
    {Coeficiente de Aversin al Riesgo. [ 0 , 1 ] Este coeficiente modula entre}
    CAR: NReal;
    { Por defecto es true. Si es false usa VaR en lugar de CVaR. }
    CAR_CVaR: boolean;
    {Especifica si la sala debe ser tratada como determinstica. }
    Deterministico: boolean;
    NPostes: integer;
    {Duracin del paso en minutos.
     TRUE Minutal en ese caso se usa DurPaso_minutos para
     definir un nico poste con duracin DurPaso_minutos/60.0
     al momento de preparar la Sala.}
    DurPaso_minutos: NReal;
    FactorEmisiones_MargenOperativoTipo: integer;
    {0: Promedio; 1: Simple; 2: Simple Ajustado}
    FactorEmisiones_ProyectoEolicoSolar: boolean;
    fechaIniOpt: TFecha;
    fechaFinOpt: TFecha; // Horizonte de Optimizacin
    fechaIniSim: TFecha;
    fechaFinSim: TFecha; // Horizonte de Simulacin
    fechaGuardaSim: TFecha; // Si esta fecha es > fechaIniSim todo lo que pase
    // antes de esta fecha NO se escribe en los archivos de resultados.
    // en particular NO se tienen en cuenta en los calculos para SimCosto.
    iteracion_flucar_Archivo_Flucar: string;
    iteracion_flucar_modificar_rendimiento: boolean;
    iteracion_flucar_modificar_capacidad: boolean;
    iteracion_flucar_modificar_peaje: boolean;
    NCronicasSim: integer; // cantidad de historias a sortear en el simulador
    NCronicasOpt: integer;
    // el valor esperado del costo futuro de operacin.
    NDiscHistoCF: integer;
    NMAX_ITERACIONESDELPASO_OPT: integer;
    NMAX_ITERACIONESDELPASO_SIM: integer;
    // Por defecto a False, si se pone a true, no se consideran las disponibilidades
    ObligarDisponibilidad_1_Sim: boolean;
    ObligarDisponibilidad_1_Opt: boolean;
    // Por defecto a FALSE. Si se marca, se obliga a tratar la disponibilidad de
    // todas las unidades como inciertas al inicio de cada crnica.
    ObligarInicioCronicaIncierto_1_Sim: boolean;
    PostesMonotonos: boolean; // TRUE por defecto.
    // cantidad de puntos usados para el mantenimienot del histograma de Costo Futuro.
    probLimiteRiesgo: NReal; // Probabilidad de Excedencia para clculo de riesgo
    //Para reducir el peso de los archivos de resultados de simulacin
    //solo se imprimiran las variables usadas en la plantilla de simres3
    publicarSoloVariablesUsadasEnSimRes3: boolean;
    restarUtilidadesDelCostoFuturo: boolean; // determina
    // Semillas iniciales para Opt y Sim
    semilla_inicial_sim, semilla_inicial_opt: integer;
    // Por defecto a TRUE, si se pone a FALSE no usa sorteos en la optimizacin y pone
    // los valores esperados de las cosas
    SortearOpt: boolean;
    TasaDeActualizacion: NReal; // tasa de descuento anual
    usar_CAR: boolean; // si est a false optimiza con el criterio clsico de minmizar
    flg_ReservaRotante: boolean;
    SalaMinutal: boolean; // FALSE Horario con durpos.

    invDurPos: TDAOfNReal; //Duracin en horas de los postes y sus inversos

    husoHorario_UTC: NReal; // -3 para Uruguay.  Universal Time Coordinated

    {$IFDEF CALC_MMEE}
    mmee_TopeDelSpot: NReal;
    mmee_PrecioSpot: TDAOfNReal;
    mmee_SeguimientoDeLaDemanda_USD: TDAOfNReal;
    {$ENDIF}

    // para cada hora del paso tiene el ndice del poste
    // esta clasificacin la hace la Demanda NETA.
    kPosteHorasDelPaso: TDAOfNInt;

    {$IFDEF CALC_DEMANDA_NETA}
    Suma_PHorarias: TDAOfNReal;

    // Tiene la aproximacin entera de las duraciones de los postes.
    NHorasDelPoste: TDAOfNInt;

    // tiene en forma ordenada del poste 1 al ltimo el ndice de las
    // horas que result del postizado del paso. Este es el ndice inverso
    // del mantenido en kPostesHorasDelPaso.
    idxHorasPostizadas: TDAOfNInt;

    // almacena el inicio de cada poste en idxHorasPostizadas
    kBasePosete_idxHorasPostizadas: TDAOfNInt;
    {$ENDIF}

    fActPaso: NReal;

    invNCronicasSim, invNCronicasOpt: NReal; //1 / NCronicas...

    ActualizadorLPD: TActualizadorFichasLPD;
    abortarSim: boolean;

    // esta variable puesta a TRUE obliga la disponibilidad a 1 en SorteosDelPaso
    // La simulacin la debe carcar con ObligarDisponibilidad_1_Sim y la optimizacin
    // la debe cargar ObligarDispnibilidad_1_Opt.
    ObligarDisponibilidad_1_: boolean;

    // la minimizacin en valor esperad CAR= 0 y la minimizacin del VaR( probLimiteRiesgo ) si CAR = 1
    // en los valores intermedios se utiliza la combinacin lineal convexa de ambos criterios.

    NPasos: integer;

    // variables del simulador
    FechaInicioDelpaso: TFecha;
    FechaFinDelPaso: TFecha;
    kPaso_: integer;

    // variable auxiliar que utilizan las fuentes submuestreadas para
    // saber el subpaso en que estn cuando realizan los sorteosDelPaso
    kSubPaso_: integer;

    //Utilizada por los hilos para saber que vuelta de sorteos del paso
    //estoy realizando sobre el paso en preparar paso ps
    iTareaEjecutando: integer;

    AnioInicioDelPaso: word;
    SemanaInicioDelPaso: word;
    //[1..52] La semana del ao por la que va la simulacion
    HoraDeInicioDelPaso: word;    // [0..23]

    MesInicioDelPaso: word;    //el mes del ao por el que va la simulacin.
    DiaDelMesInicioDelPaso: word;
    DiaDeLaSemanaInicioDelPaso: word;
    DiaDelAnioInicioDelPaso: word;
    HoraDelAnioInicioDelPaso: word;
    FechaInicioDelAnio: TDateTime;
    TipoDeDiaInicioDelPaso: TTipoDeDia;

    dt_DelPaso: NReal; // duracin del paso de tiempo en das punto flontante

    HorasDelPaso: NReal;

    SegundosDelPaso: integer;
    invHorasDelPaso, invSegundosDelPaso: NReal;

    ultimaSemillaFijada: integer;
    // 1 / HorasDelPaso, 1 / SegundosDelPaso
    kCronica: integer;

    cntIteracionesDelPaso: integer;


    // Resultado de la optimizacin del paso.
    CostoDelPaso: NReal;

    // Soporte de estados y costos futuros
    CF: TAdminEstados;

    liberarAuxs: boolean;
    Auxs_r0, Auxs_r1: TDAOfDAOfNReal;
    Auxs_i0, Auxs_i1: TDAOfDAOfNInt;

    {$IFDEF PDE_RIESGO}
    HistoCF0: TDAofDAofNReal;
    // Histograma del costo Futuro Al Inicio de la etapa durante OPT
    // La dimensin es NEstrellas x NSorteosOpt x NPuntosHistoCF
    // HistoCF0[ kEstrella ][ kCronOpt * NDiscHistoCF + j ] con j: 0.. NDiscHistoCF - 1

    HistoCF1_: TDAofDAofNReal;
    // Histograma del Costo Futuro al Fin de la etapa durante OPT.
    // La dimsensin es NEstrellas x NPuntosHistoCF
    HistoCF1_s: TDAofDAofNReal; // este es auxiliar para clculo para que no se
    // mezclen en el caso de los multi-hilo
    {$ENDIF}

    // se para que los actores que actualizan el estado se fijen
    // si se debe usar la reduccin de estados auxiliar (si es que tiene)
    CFauxActivo: boolean;

    procNot_InicioSimulacion: TProcNotificacion;
    procNot_InicioCronica: TProcNotificacion;
    procNot_InicioPaso: TProcNotificacion;
    procNot_FinPaso: TProcNotificacion;
    procNot_FinCronica: TProcNotificacion;
    procNot_FinSimulacion: TProcNotificacion;

    procNot_opt_InicioOptimizacion: TProcNotificacion;
    procNot_opt_InicioCronicaSorteos: TProcNotificacion;
    procNot_opt_PrepararPaso_ps: TProcNotificacion;
    procNot_opt_InicioCalculosDeEtapa: TProcNotificacion;
    procNot_opt_FinCalculosDeEtapa: TProcNotificacion;
    procNot_opt_FinCronicaSorteos: TProcNotificacion;
    procNot_opt_FinOptimizacion: TProcNotificacion;

    EstadoDeLaSala: TEstadoDeLaSala;

    MadresUniformes: TMadresUniformes;

    EscenarioActivo: TEscenario_rec; // apunta al de la sala si esta activ un escenario


    //{$IFDEF DBG}
    //      fdbgAbierto: Boolean;
    //      fdbg: TextFile; //Es un archivo que se mantiene abierto durante toda la
    //                      //simulacin para escribirle valores si se desea
    //{$ENDIF}
    constructor Create(nombre: string;
      fechaIniSim, fechaFinSim, fechaGuardaSim: TFecha;
      fechaIniOpt, fechaFinOpt: TFecha; const DurPos: TDAOfNReal); reintroduce;
    {$IFNDEF MIGRACION_PERSISTENCIA}
    constructor Create_ReadFromText(f: TArchiTexto); override;
    procedure WriteToText(f: TArchiTexto); override;
    {$ENDIF}

    function calcNPasosSim: integer;
    function calcNPasosOpt: integer;
    function fechaToPasoSim(fecha: TFecha): integer;
    function pasoToFechaSim(paso: integer): TFecha;
    function fechaToPasoOpt(fecha: TFecha): integer;
    function pasoToFechaOpt(paso: integer): TFecha;

    // fija el kPaso, el kSem y el kMes
    procedure Fijar_kPaso(nuevo_kPaso: integer);
    procedure Fijar_FechaInicioDelPaso(fecha: TFecha);
    procedure fijarSemillaAleatoria_(semilla: integer);

    procedure CalcularConstantesBasicasDelPaso;
    procedure Free; override;

    procedure CambioFichaPD; override;
    //Abstracto lanza Excepcion

    // pone todos los procedimientos de notificacin a NIL.
    procedure ClearProcNots;

    // si xproc es <> nil lo ejecuta
    procedure procNot(xproc: TProcNotificacion);
    procedure deshabilitarAlertas;
    procedure habilitarAlertas;
    procedure setProcAlerta(xprocAlerta: TProcAlerta);
    procedure Alerta(const s: string);

    procedure PubliVars; override;

    procedure ClearAuxs1(kIniEstrella, kFinEstrella: integer); // limpia los auxs1
    procedure SwapAuxs;   // conmuta los frames auxilieares 0<->1
    procedure MultAuxs1(mmult: NReal);
    // Los enteros los multiplica y redondea al entero ms proximo

   {$IFDEF CALC_DEMANDA_NETA}
    procedure InicializarNeteadorDeDemanda;
    procedure borrarSumaPHorarias;
    procedure sumarPHoraria(const PHoraria: TDAOfNReal);
    procedure restarPHoraria(const PHoraria: TDAOfNReal);
    procedure postizarPHoraria;
    {$ELSE}
    procedure SetDemandaPrincipal(aDemanda: TCosa);
    function GetDemandaPrincipal: TCosa;
    {$ENDIF}

    {$IFDEF MIGRACION_PERSISTENCIA}
    class function CreateDataConversionList(): TListDataConversion; override;
    class function CreateDataColumnList(xClaseDeCosa: TClaseDeCosa;
      xVersion: integer = -2): TDataColumnListOfCosa; override;
    {$ENDIF}

    procedure AfterInstantiation; override;

    function Validate(): boolean; override;


  published
    {$IFDEF MIGRACION_PERSISTENCIA}
    property _Calcular_EmisionesCO2: boolean
      read Calcular_EmisionesCO2 write Calcular_EmisionesCO2;
    property _CAR: NReal
      read CAR write CAR;
    property _CAR_CVaR: boolean
      read CAR_CVaR write CAR_CVaR;
    property _Deterministico: boolean
      read Deterministico write Deterministico;
    property _NPostes: integer
      read NPostes write NPostes;
    property _DurPos: TDAOfNReal
      read DurPos write DurPos;
    property _SalaMinutal: boolean
      read SalaMinutal write SalaMinutal;
    property _DurPaso_minutos: NReal
      read DurPaso_minutos write DurPaso_minutos;
    property _FactorEmisiones_MargenOperativoTipo: integer
      read FactorEmisiones_MargenOperativoTipo write FactorEmisiones_MargenOperativoTipo;
    property _FactorEmisiones_ProyectoEolicoSolar: boolean
      read FactorEmisiones_ProyectoEolicoSolar write FactorEmisiones_ProyectoEolicoSolar;
    property _FechaIniOpt: TFecha
      read fechaIniOpt write fechaIniOpt;
    property _FechaFinOpt: TFecha
      read fechaFinOpt write fechaFinOpt;
    property _FechaIniSim: TFecha
      read fechaIniSim write fechaIniSim;
    property _FechaFinSim: TFecha
      read fechaFinSim write fechaFinSim;
    property _FechaGuardaSim: TFecha
      read fechaGuardaSim write fechaGuardaSim;
    property _Iteracion_flucar_Archivo_Flucar: string
      read iteracion_flucar_Archivo_Flucar write iteracion_flucar_Archivo_Flucar;
    property _Iteracion_flucar_modificar_rendimiento: boolean
      read iteracion_flucar_modificar_capacidad write iteracion_flucar_modificar_capacidad;
    property _Iteracion_flucar_modificar_capacidad: boolean
      read iteracion_flucar_modificar_rendimiento write iteracion_flucar_modificar_rendimiento;
    property _Iteracion_flucar_modificar_peaje: boolean
      read iteracion_flucar_modificar_peaje write iteracion_flucar_modificar_peaje;
    property _NCronicasSim: integer
      read NCronicasSim write NCronicasSim;
    property _NCronicasOpt: integer
      read NCronicasOpt write NCronicasOpt;
    property _NDiscHistoCF: integer
      read NDiscHistoCF write NDiscHistoCF;
    property _NMAX_ITERACIONESDELPASO_OPT: integer
      read NMAX_ITERACIONESDELPASO_OPT write NMAX_ITERACIONESDELPASO_OPT;
    property _NMAX_ITERACIONESDELPASO_SIM: integer
      read NMAX_ITERACIONESDELPASO_SIM write NMAX_ITERACIONESDELPASO_SIM;
    property _ObligarDisponibilidad_1_Sim: boolean
      read ObligarDisponibilidad_1_Sim write ObligarDisponibilidad_1_Sim;
    property _ObligarDisponibilidad_1_Opt: boolean
      read ObligarDisponibilidad_1_Opt write ObligarDisponibilidad_1_Opt;
    property _ObligarInicioCronicaIncierto_1_Sim: boolean
      read ObligarInicioCronicaIncierto_1_Sim write ObligarInicioCronicaIncierto_1_Sim;
    property _PostesMonotonos: boolean
      read PostesMonotonos write PostesMonotonos;
    property _ProbLimiteRiesgo: NReal
      read probLimiteRiesgo write probLimiteRiesgo;
    property _PublicarSoloVariablesUsadasEnSimRes3: boolean
      read publicarSoloVariablesUsadasEnSimRes3 write publicarSoloVariablesUsadasEnSimRes3;
    property _RestarUtilidadesDelCostoFuturo: boolean
      read restarUtilidadesDelCostoFuturo write restarUtilidadesDelCostoFuturo;
    property _Semilla_inicial_sim: integer
      read semilla_inicial_sim write semilla_inicial_sim;
    property _Semilla_inicial_opt: integer
      read semilla_inicial_opt write semilla_inicial_opt;
    property _SortearOpt: boolean
      read SortearOpt write SortearOpt;
    property _TasaDeActualizacion: NReal
      read tasaDeActualizacion write tasaDeActualizacion;
    property _Usar_CAR: boolean
      read usar_CAR write usar_CAR;
    property _flg_ReservaRotante: boolean
      read flg_ReservaRotante write flg_ReservaRotante;
    {$ENDIF}



  end;

function estadoSalaToString(estado: TEstadoDeLaSala): string;

procedure AlInicio;
procedure AlFinal;

implementation

function estadoSalaToString(estado: TEstadoDeLaSala): string;
begin
  case estado of
    CES_SIN_PREPARAR: Result := 'CES_SIN_PREPARAR';
    CES_OPTIMIZANDO: Result := 'CES_OPTIMIZANDO';
    CES_OPTIMIZACION_TERMINADA: Result := 'CES_OPTIMIZACION_TERMINADA';
    CES_OPTIMIZACION_ABORTADA: Result := 'CES_OPTIMIZACION_ABORTADA';
    CES_SIMULANDO: Result := 'CES_SIMULANDO';
    CES_SIMULACION_TERMINADA: Result := 'CES_SIMULACION_TERMINADA';
    CES_SIMULACION_ABORTADA: Result := 'CES_SIMULACION_ABORTADA';
    else
      raise Exception.Create('uglobs.estadoSalaToString, estado desconocido');
  end;
end;

procedure TGlobs.deshabilitarAlertas;
begin
  procAlertaHabilitado := False;
end;

procedure TGlobs.habilitarAlertas;
begin
  procAlertaHabilitado := True;
end;

procedure TGlobs.setProcAlerta(xprocAlerta: TProcAlerta);
begin
  procAlerta := xprocAlerta;
  procAlertaHabilitado := Assigned(xprocAlerta);
end;

procedure TGlobs.Alerta(const s: string);
begin
  if procAlertaHabilitado then
    procAlerta(s);
end;

{$IFDEF CALC_DEMANDA_NETA}
procedure TGlobs.InicializarNeteadorDeDemanda;
var
  iposte: integer;
  nHorasDelPoste_: integer;
  kBasePoste: integer;

begin
  setlength(Suma_PHorarias, max(round(HorasDelPaso), 1));
  setlength(idxHorasPostizadas, max(round(HorasDelPaso), 1));
  setlength(kBasePosete_idxHorasPostizadas, NPostes + 1);
  setlength(NHorasDelPoste, NPostes);

  kBasePoste := 0;
  for iposte := 0 to NPostes - 1 do
  begin
    nHorasDelPoste_ := round(Durpos[iposte]);
    nHorasDelPoste[iposte] := nHorasDelPoste_;
    kBasePoste := kBasePoste + nHorasDelPoste_;
    kBasePosete_idxHorasPostizadas[iposte + 1] := kBasePoste;
  end;
end;

procedure TGlobs.borrarSumaPHorarias;
begin
  vclear(Suma_PHorarias);
end;

procedure TGlobs.restarPHoraria(const PHoraria: TDAOfNReal);
var
  k: integer;
begin
  for k := 0 to high(PHoraria) do
    Suma_PHorarias[k] := Suma_PHorarias[k] - PHoraria[k];
end;


procedure TGlobs.sumarPHoraria(const PHoraria: TDAOfNReal);
var
  k: integer;
begin
  for k := 0 to high(PHoraria) do
    Suma_PHorarias[k] := Suma_PHorarias[k] + PHoraria[k];
end;

procedure TGlobs.postizarPHoraria;
var
  k: integer;
  hora, jhora: integer;
  iposte: integer;
begin
  // inicializamos el ndice
  for k := 0 to high(idxHorasPostizadas) do
    idxHorasPostizadas[k] := k;

  if PostesMonotonos then
    QuickSort_Decreciente(Suma_PHorarias, idxHorasPostizadas);

  hora := 0;
  kBasePosete_idxHorasPostizadas[0] := 0;
  for iposte := 0 to NPostes - 1 do
  begin
    for jhora := 0 to nHorasDelPoste[iposte] - 1 do
    begin
      kPosteHorasDelPaso[idxHorasPostizadas[hora]] := iposte;
      Inc(hora);
    end;
  end;
end;

{$ELSE}


procedure TGlobs.SetDemandaPrincipal(aDemanda: TCosa);
begin
  DemandaPrincipal := aDemanda;
end;

function TGlobs.GetDemandaPrincipal: TCosa;
begin
  Result := DemandaPrincipal;
end;

{$ENDIF}


constructor TGlobs.Create(nombre: string;
  fechaIniSim, fechaFinSim, fechaGuardaSim: TFecha; fechaIniOpt, fechaFinOpt: TFecha;
  const DurPos: TDAOfNReal);
var
  i: integer;
  acumr: NReal;
begin
  inherited Create(0, nombre);
  EscenarioActivo := nil;

  EstadoDeLaSala := CES_SIN_PREPARAR;
  ActualizadorLPD := TActualizadorFichasLPD.Create;
  abortarSim := False;
  self.fechaIniSim := fechaIniSim;
  self.fechaFinSim := fechaFinSim;
  self.fechaGuardaSim := fechaGuardaSim;
  self.fechaIniOpt := fechaIniOpt;
  self.fechaFinOpt := fechaFinOpt;
  Self.NPostes := length(DurPos);
  self.DurPos := copy(DurPos, 0, NPostes);
  SetLength(invDurPos, NPostes);

    {$IFDEF CALC_MMEE}
  mmee_TopeDelSpot := 250.0; // ojo esto es para sobreescribir al leer
  setlength(mmee_PrecioSpot, NPostes);
  setlength(mmee_SeguimientoDeLaDemanda_USD, NPostes);
    {$ENDIF}

  for i := 0 to high(DurPos) do
    invDurPos[i] := 1 / durPos[i];

  acumr := vsum(DurPos);
  dt_DelPaso := acumr / 24.0;
  HorasDelPaso := acumr;
  invHorasDelPaso := 1 / HorasDelPaso;

  setLength(kPosteHorasDelPaso, ceil(HorasDelPaso));
  demandaPrincipal := nil;

  SegundosDelPaso := trunc(HorasDelPaso * 3600 + 0.1);
  invSegundosDelPaso := 1 / SegundosDelPaso;
  FechaInicioDelpaso := TFecha.Create_Clone(fechaIniOpt);
  FechaFinDelPaso := TFecha.Create_OffsetDT(FechaInicioDelpaso, dt_DelPaso);

  PostesMonotonos := True;
  SalaMinutal := False;
  DurPaso_minutos := 10.0;

  self.SortearOpt := True;
  ObligarDisponibilidad_1_Sim := False;
  ObligarDisponibilidad_1_Opt := False;
  ObligarInicioCronicaIncierto_1_Sim := False;
  Deterministico := False;
  self.semilla_inicial_sim := 31;
  self.semilla_inicial_opt := 31;

  CF := nil;
  setlength(Auxs_r0, 0);
  setlength(Auxs_i0, 0);
  setlength(Auxs_r1, 0);
  setlength(Auxs_i1, 0);
  MadresUniformes := TMadresUniformes.Create(10000);

  self.usar_CAR := False;
  self.restarUtilidadesDelCostoFuturo := True;
  NDiscHistoCF := 0;
  probLimiteRiesgo := 0.0;
  CAR := 0.0;
  CAR_CVaR := True;

  {$IFDEF PDE_RIESGO}
  setlength(HistoCF0, 0);
  setlength(HistoCF1_, 0);
  setlength(HistoCF1_s, 0);
  {$ENDIF}

  Fijar_kPaso(1); // solo para que inicialmente est algo definido
  //{$IFDEF DBG}
  //  AssignFile(fdbg, uconstantes.getDir_Dbg + 'debug.txt');
  //  rewrite(fdbg);
  //  fdbgAbierto:= true;
  //{$ENDIF}
  procAlertaHabilitado := False;


  NMAX_ITERACIONESDELPASO_OPT := 0;
  NMAX_ITERACIONESDELPASO_SIM := 4;


  {$IFDEF CALC_DEMANDA_NETA}
  setlength(Suma_PHorarias, 0);
  setlength(idxHorasPostizadas, 0);
  setlength(kBasePosete_idxHorasPostizadas, 0);
  setlength(NHorasDelPoste, 0);
  {$ENDIF}

  publicarSoloVariablesUsadasEnSimRes3 := True;
  flg_ReservaRotante := False;
end;

procedure TGlobs.Fijar_kPaso(nuevo_kPaso: integer);
begin
  kPaso_ := nuevo_kPaso;
  if EstadoDeLaSala = CES_OPTIMIZANDO then
    FechaInicioDelpaso.PonerIgualAMasOffsetDT(
      fechaIniOpt, dt_DelPaso * (kPaso_ - 1))
  else
    FechaInicioDelpaso.PonerIgualAMasOffsetDT(
      fechaIniSim, dt_DelPaso * (kPaso_ - 1));
  Fijar_FechaInicioDelPaso(FechaInicioDelpaso);
end;

procedure TGlobs.Fijar_FechaInicioDelPaso(fecha: TFecha);
var
  anio: word;
begin
  FechaInicioDelpaso.PonerIgualA(fecha);

  //  FechaFinDelPaso.PonerIgualAMasOffsetDT(FechaInicioDelpaso, dt_DelPaso - 1);   //rch@201501222003 ... ??? OJO me parece que el -1 es un bolazo!!!
  FechaFinDelPaso.PonerIgualAMasOffsetDT(FechaInicioDelpaso, dt_DelPaso);
  DecodeDate(FechaInicioDelPaso.dt, anio, mesInicioDelPaso, diaDelMesInicioDelPaso);
  if anio <> anioInicioDelPaso then
  begin
    fechaInicioDelAnio := encodeDate(anio, 1, 1);
    anioInicioDelPaso := anio;
  end;
  //  SemanaInicioDelPaso:= trunc(( FechaInicioDelPaso.dt-fechaInicioDelAnio )/7)+1;
  SemanaInicioDelPaso := trunc((FechaInicioDelPaso.dt - fechaInicioDelAnio) /
    7.038461538) + 1;
  DiaDelAnioInicioDelPaso := trunc(FechaInicioDelPaso.dt - fechaInicioDelAnio) + 1;
  DiaDeLaSemanaInicioDelPaso := DayOfWeek(FechaInicioDelpaso.dt);

  if DiaDeLaSemanaInicioDelPaso = 1 then // domingo
    TipoDeDiaInicioDelPaso := DIA_FERIADO
  else if DiaDeLaSemanaInicioDelPaso = 7 then // sbado
    TipoDeDiaInicioDelPaso := DIA_SEMI_FERIADO
  else
    TipoDeDiaInicioDelPaso := DIA_HABIL;

  if SemanaInicioDelPaso > 52 then
    SemanaInicioDelPaso := 52;

  HoraDeInicioDelPaso := FechaInicioDelPaso.hora;

  HoraDelAnioInicioDelPaso := trunc((FechaInicioDelPaso.dt - FechaInicioDelAnio) * 24);
end;

procedure TGlobs.fijarSemillaAleatoria_(semilla: integer);
begin
  self.ultimaSemillaFijada := semilla;
  MadresUniformes.Reiniciar(semilla);
end;


procedure TGlobs.CalcularConstantesBasicasDelPaso;
var
  acumr: NReal;
begin
  if SalaMinutal then
  begin
    NPostes := 1;
    setlength(self.DurPos, 1);
    DurPos[0] := DurPaso_minutos / 60.0;
  end;
  acumr := vsum(self.DurPos);
  dt_DelPaso := acumr / 24.0;
  HorasDelPaso := acumr;
end;

{$IFNDEF MIGRACION_PERSISTENCIA}
constructor TGlobs.Create_ReadFromText(f: TArchiTexto);
var
  i: integer;
begin
  inherited Create_ReadFromText(f);

  {$IFDEF CALC_DEMANDA_NETA}
  setlength(Suma_PHorarias, 0);
  setlength(idxHorasPostizadas, 0);
  setlength(kBasePosete_idxHorasPostizadas, 0);
  setlength(NHorasDelPoste, 0);
  {$ENDIF}

  EscenarioActivo := nil;

  Calcular_EmisionesCO2 := False;
  self.restarUtilidadesDelCostoFuturo := False;

  //iteracion_flucar_Archivo_Flucar:= '';
  self.iteracion_flucar_modificar_rendimiento := True;
  self.iteracion_flucar_modificar_capacidad := True;
  self.iteracion_flucar_modificar_peaje := False;

  self.FactorEmisiones_MargenOperativoTipo := 0;
  self.FactorEmisiones_ProyectoEolicoSolar := True;
  self.CAR_CVaR := True;

  self.ObligarInicioCronicaIncierto_1_Sim := False;

  fechaGuardaSim := nil;

  SalaMinutal := False;
  DurPaso_minutos := 10.0;

  if f.Version < 25 then
  begin
    fechaIni_old := nil;
    fechaFin_old := nil;
    fechaIniSim := nil;
    fechaFinSim := nil;
    fechaIniOpt := nil;
    fechaFinOpt := nil;

    f.IniciarLecturaRetrasada;
    f.rd('NPostes', self.NPostes);

    f.rd('fechaIni', self.fechaIni_old, 1);
    f.rd('fechaFin', self.fechaFin_old, 1);

    f.rd('fechaIniSim', self.fechaIniSim, 1);
    f.rd('fechaFinSim', self.fechaFinSim, 1);
    f.rd('fechaIniOpt', self.fechaIniOpt, 1);
    f.rd('fechaFinOpt', self.fechaFinOpt, 1);

    f.rd('durpos', self.durpos);
    f.rd('tasaDeActualizacion', self.TasaDeActualizacion);
    f.rd('NCronicasSim', self.NCronicasSim);
    f.rd('NCronicasOpt', self.NCronicasOpt);
    f.rd('ObligarDisponibilidad_1', self.ObligarDisponibilidad_1_Sim);

    self.ObligarDisponibilidad_1_Opt := False;
    self.Deterministico := False;
    f.rd('SortearOpt', self.SortearOpt);
    f.rd('PostesMonotonos', self.PostesMonotonos);

    f.EjecutarLectura;

    if (fechaIniSim = nil) or (fechaIniSim.dt = 0) then
      fechaIniSim := fechaIni_old;
    if (fechaFinSim = nil) or (fechaFinSim.dt = 0) then
      fechaFinSim := fechaFin_old;

    if (fechaIniOpt = nil) or (fechaIniOpt.dt = 0) then
      fechaIniOpt := fechaIni_old;
    if (fechaFinOpt = nil) or (fechaFinOpt.dt = 0) then
      fechaFinOpt := fechaFin_old;

    NMAX_ITERACIONESDELPASO_OPT := 0;
    NMAX_ITERACIONESDELPASO_SIM := 4;

    self.usar_CAR := False;
    self.NDiscHistoCF := 0;
    self.probLimiteRiesgo := 0.0;
    self.CAR := 0.0;

    //{$IFDEF DBG}
    //  AssignFile(fdbg, uconstantes.getDir_Dbg + 'debug.txt');
    //  rewrite(fdbg);
    //{$ENDIF}
    procAlertaHabilitado := False;
  end
  else
  begin
    fechaIni_old := nil;
    fechaFin_old := nil;
    fechaIniSim := nil;
    fechaFinSim := nil;
    fechaIniOpt := nil;
    fechaFinOpt := nil;

    f.IniciarLecturaRetrasada;
    f.rd('NPostes', self.NPostes);


    f.rd('fechaIni', fechaIni_old, 1);
    f.rd('fechaFin', fechaFin_old, 1);
    f.rd('fechaIniSim', self.fechaIniSim, 1);
    f.rd('fechaFinSim', self.fechaFinSim, 1);
    if (f.Version >= 102) then
      f.rd('fechaGuardaSim', self.fechaGuardaSim)
    else
      fechaGuardaSim := TFecha.Create_Dt(0);

    f.rd('fechaIniOpt', self.fechaIniOpt, 1);
    f.rd('fechaFinOpt', self.fechaFinOpt, 1);

    f.rd('durpos', self.durpos);

    if f.Version >= 104 then
    begin
      f.rd('SalaMinutal', self.SalaMinutal);
      f.rd('DurPaso_minutos', self.DurPaso_minutos);
    end;

    f.rd('tasaDeActualizacion', self.TasaDeActualizacion);
    f.rd('NCronicasSim', self.NCronicasSim);
    f.rd('NCronicasOpt', self.NCronicasOpt);

    if f.Version >= 99 then
    begin
      f.rd('semilla_inicial_sim', self.semilla_inicial_sim);
      f.rd('semilla_inicial_opt', self.semilla_inicial_opt);
    end
    else
    begin
      self.semilla_inicial_sim := 31;
      self.semilla_inicial_opt := 31;
    end;

    if f.version < 87 then
    begin
      f.rd('ObligarDisponibilidad_1', self.ObligarDisponibilidad_1_Sim);
      self.ObligarDisponibilidad_1_Opt := False;
    end
    else
    begin
      f.rd('ObligarDisponibilidad_1_Sim', self.ObligarDisponibilidad_1_Sim);
      f.rd('ObligarDisponibilidad_1_Opt', self.ObligarDisponibilidad_1_Opt);
    end;

    if f.Version >= 101 then
      f.rd('ObligarInicioCronicaIncierto_1_Sim',
        self.ObligarInicioCronicaIncierto_1_Sim);


    if f.version < 88 then
      self.Deterministico := False
    else
      f.rd('Deterministico', self.Deterministico);

    f.rd('SortearOpt', self.SortearOpt);
    f.rd('PostesMonotonos', self.PostesMonotonos);
    f.rd('NMAX_ITERACIONESDELPASO_OPT', self.NMAX_ITERACIONESDELPASO_OPT);
    f.rd('NMAX_ITERACIONESDELPASO_SIM', self.NMAX_ITERACIONESDELPASO_SIM);


    if f.Version < 59 then
    begin
      self.usar_CAR := False;
      self.NDiscHistoCF := 0;
      self.probLimiteRiesgo := 0.0;
      self.CAR := 0.0;
    end
    else
    begin
      f.rd('usar_CAR', self.usar_CAR);
      f.rd('NDiscHistoCF', self.NDiscHistoCF);
      f.rd('probLimiteRiesgo', self.probLimiteRiesgo);
      f.rd('CAR', self.CAR);
    end;

    if f.Version >= 97 then
      f.rd('CAR_CVaR', self.CAR_CVaR);


    if f.Version >= 63 then
      f.rd('Calcular_EmisionesCO2', self.Calcular_EmisionesCO2);

    if f.Version >= 68 then
    begin
      f.rd('FactorEmisiones_MargenOperativoTipo',
        self.FactorEmisiones_MargenOperativoTipo);
      f.rd('FactorEmisiones_ProyectoEolicoSolar',
        self.FactorEmisiones_ProyectoEolicoSolar);
    end;

    if f.Version >= 74 then
    begin
      f.rd('iteracion_flucar_Archivo_Flucar', self.iteracion_flucar_Archivo_Flucar);
      f.rd('iteracion_flucar_modificar_rendimiento',
        self.iteracion_flucar_modificar_rendimiento);
      f.rd('iteracion_flucar_modificar_capacidad',
        self.iteracion_flucar_modificar_capacidad);
      f.rd('iteracion_flucar_modificar_peaje', self.iteracion_flucar_modificar_peaje);
    end;

    if f.Version >= 84 then
    begin
      f.rd('RestarUtilidadesDelCostoFuturo', self.restarUtilidadesDelCostoFuturo);
    end;

    if f.version > 108 then
      f.rd('publicarSoloVariablesUsadasEnSimRes3',
        self.publicarSoloVariablesUsadasEnSimRes3)
    else
      self.publicarSoloVariablesUsadasEnSimRes3 := False;

    if f.Version > 130 then
      f.rd('flg_ReservaRotante', self.flg_ReservaRotante)
    else
      self.flg_ReservaRotante := False;

    {$IFDEF PDE_RIESGO}
    setlength(HistoCF0, 0);
    setlength(HistoCF1_, 0);
    setlength(HistoCF1_s, 0);
    {$ENDIF}

    f.EjecutarLectura;

    if (fechaIniSim = nil) or (fechaIniSim.dt = 0) then
      fechaIniSim := fechaIni_old;
    if (fechaFinSim = nil) or (fechaFinSim.dt = 0) then
      fechaFinSim := fechaFin_old;

    if (fechaIniOpt = nil) or (fechaIniOpt.dt = 0) then
      fechaIniOpt := fechaIni_old;
    if (fechaFinOpt = nil) or (fechaFinOpt.dt = 0) then
      fechaFinOpt := fechaFin_old;

    //{$IFDEF DBG}
    //  AssignFile(fdbg, uconstantes.getDir_Dbg + 'debug.txt');
    //  rewrite(fdbg);
    //{$ENDIF}
    procAlertaHabilitado := False;

  end;

  calcularConstantesBasicasDelPaso;


  setLength(kPosteHorasDelPaso, ceil(HorasDelPaso));
  demandaPrincipal := nil;

  {$IFDEF CALC_MMEE}
  mmee_TopeDelSpot := 250.0; // ojo esto es para sobreescribir al leer
  setlength(mmee_PrecioSpot, NPostes);
  setlength(mmee_SeguimientoDeLaDemanda_USD, NPostes);
  {$ENDIF}

  // rch@feb2016 - Este parmetro debe ser pasado a Persistente cuando hagmos
  // otro cambio que amerite un cambio de versin de archivo de sala.
  husoHorario_UTC := -3;


  SetLength(invDurPos, length(DurPos));
  for i := 0 to high(DurPos) do
    invDurPos[i] := 1 / durPos[i];

  invHorasDelPaso := 1 / HorasDelPaso;
  SegundosDelPaso := trunc(HorasDelPaso * 3600 + 0.1);
  invSegundosDelPaso := 1 / SegundosDelPaso;
  EstadoDeLaSala := CES_SIN_PREPARAR;
  ActualizadorLPD := TActualizadorFichasLPD.Create;
  FechaInicioDelpaso := TFecha.Create_Clone(fechaIniOpt);
  FechaFinDelPaso := TFecha.Create_OffsetHoras(FechaInicioDelpaso, HorasDelPaso);
  CF := nil;
  clearProcNots;
  MadresUniformes := TMadresUniformes.Create(10000);
  Fijar_kPaso(1); // solo para que inicialmente est algo definido
end;

procedure TGlobs.WriteToText(f: TArchiTexto);
begin
  inherited WriteToText(f);
  f.wr('NPostes', NPostes);
  f.wr('fechaIniSim', fechaIniSim);
  f.wr('fechaFinSim', fechaFinSim);
  f.wr('fechaGuardaSim', fechaGuardaSim);
  f.wr('fechaIniOpt', fechaIniOpt);
  f.wr('fechaFinOpt', fechaFinOpt);
  f.wr('durpos', durpos, 8, 2);
  f.wr('SalaMinutal', SalaMinutal);
  f.wr('DurPaso_minutos', DurPaso_minutos);
  f.wr('tasaDeActualizacion', self.TasaDeActualizacion, 8, 3);
  f.wr('NCronicasSim', self.NCronicasSim);
  f.wr('NCronicasOpt', self.NCronicasOpt);
  f.wr('semilla_inicial_sim', self.semilla_inicial_sim);
  f.wr('semilla_inicial_opt', self.semilla_inicial_opt);
  f.wr('ObligarDisponibilidad_1_Sim', self.ObligarDisponibilidad_1_Sim);
  f.wr('ObligarDisponibilidad_1_Opt', self.ObligarDisponibilidad_1_Opt);
  f.wr('ObligarInicioCronicaIncierto_1_Sim', self.ObligarInicioCronicaIncierto_1_Sim);
  f.wr('Deterministico', self.Deterministico);
  f.wr('SortearOpt', self.SortearOpt);
  f.wr('PostesMonotonos', self.PostesMonotonos);
  f.wr('NMAX_ITERACIONESDELPASO_OPT', self.NMAX_ITERACIONESDELPASO_OPT);
  f.wr('NMAX_ITERACIONESDELPASO_SIM', self.NMAX_ITERACIONESDELPASO_SIM);
  f.wr('usar_CAR', self.usar_CAR);
  f.wr('NDiscHistoCF', self.NDiscHistoCF);
  f.wr('probLimiteRiesgo', self.probLimiteRiesgo);
  f.wr('CAR', self.CAR);
  f.wr('CAR_CVaR', self.CAR_CVaR);
  f.wr('Calcular_EmisionesCO2', self.Calcular_EmisionesCO2);
  f.wr('FactorEmisiones_MargenOperativoTipo', self.FactorEmisiones_MargenOperativoTipo);
  f.wr('FactorEmisiones_ProyectoEolicoSolar', self.FactorEmisiones_ProyectoEolicoSolar);
  f.wr('iteracion_flucar_Archivo_Flucar', self.iteracion_flucar_Archivo_Flucar);
  f.wr('iteracion_flucar_modificar_rendimiento',
    self.iteracion_flucar_modificar_rendimiento);
  f.wr('iteracion_flucar_modificar_capacidad',
    self.iteracion_flucar_modificar_capacidad);
  f.wr('iteracion_flucar_modificar_peaje', self.iteracion_flucar_modificar_peaje);
  f.wr('RestarUtilidadesDelCostoFuturo', self.restarUtilidadesDelCostoFuturo);
  f.wr('publicarSoloVariablesUsadasEnSimRes3',
    self.publicarSoloVariablesUsadasEnSimRes3);
  f.wr('flg_ReservaRotante', self.flg_ReservaRotante);
end;

{$ENDIF}

procedure TGlobs.ClearProcNots;
begin
  procNot_InicioSimulacion := nil;
  procNot_InicioCronica := nil;
  procNot_InicioPaso := nil;
  procNot_FinPaso := nil;
  procNot_FinCronica := nil;
  procNot_FinSimulacion := nil;

  procNot_opt_InicioOptimizacion := nil;
  procNot_opt_InicioCalculosDeEtapa := nil;
  procNot_opt_InicioCronicaSorteos := nil;
  procNot_opt_PrepararPaso_ps := nil;
  procNot_opt_FinCronicaSorteos := nil;
  procNot_opt_FinCalculosDeEtapa := nil;
  procNot_opt_FinOptimizacion := nil;

  procAlerta := nil;
  procAlertaHabilitado := False;
end;

procedure TGlobs.procNot(xproc: TProcNotificacion);
begin
  if assigned(xproc) then
    xproc;
end;

function TGlobs.calcNPasosSim: integer;
var
  rn: NReal;
begin
  rn := (fechaFinSim.dt - fechaIniSim.dt) / dt_DelPaso;
  Result := trunc(rn);
end;

function TGlobs.calcNPasosOpt: integer;
begin
  Result := trunc((fechaFinOpt.dt - fechaIniOpt.dt) / dt_DelPaso);

end;

//Retorna el paso de la simulacin comenzando de 1
function TGlobs.fechaToPasoSim(fecha: TFecha): integer;
begin
  Result := trunc((fecha.dt - fechaIniSim.dt) / dt_DelPaso) + 1;
end;

function TGlobs.pasoToFechaSim(paso: integer): TFecha;
begin
  Result := TFecha.Create_Dt(fechaIniSim.dt + (paso - 1) * dt_DelPaso);
end;

function TGlobs.fechaToPasoOpt(fecha: TFecha): integer;
begin
  Result := trunc((fecha.dt - fechaIniOpt.dt) / dt_DelPaso) + 1;
end;

function TGlobs.pasoToFechaOpt(paso: integer): TFecha;
begin
  Result := TFecha.Create_Dt(fechaIniOpt.dt + (paso - 1) * dt_DelPaso);
end;


procedure TGlobs.ClearAuxs1(kIniEstrella, kFinEstrella: integer); // limpia los auxs1
var
  k: integer;
begin
  for k := 0 to high(Auxs_r1) do
    vclear(Auxs_r1[k], kIniEstrella, kFinEstrella);
  for k := 0 to high(Auxs_i1) do
    vclear(Auxs_i1[k], kIniEstrella, kFinEstrella);
end;

procedure TGlobs.MultAuxs1(mmult: NReal);
var
  k: integer;
begin
  for k := 0 to high(Auxs_r1) do
    vmultr(Auxs_r1[k], mmult);
  for k := 0 to high(Auxs_i1) do
    vmultr(Auxs_i1[k], mmult);
end;

procedure TGlobs.SwapAuxs; // conmuta los frames auxilieares 0<->1
var
  tvr: TDAOfDAOfNReal;
  tvi: TDAOfDAOFNint;
begin
  tvr := Auxs_r0;
  Auxs_r0 := Auxs_r1;
  Auxs_r1 := tvr;

  tvi := Auxs_i0;
  Auxs_i0 := Auxs_i1;
  Auxs_i1 := tvi;

  {$IFDEF PDE_RIESGO}
  tvr := HistoCF1_;
  HistoCF1_ := HistoCF1_s;
  HistoCF1_s := tvr;
  {$ENDIF}
end;

procedure TGlobs.Free;
var
  k: integer;
begin
  setlength(self.DurPos, 0);
  SetLength(invDurPos, 0);

  {$IFDEF CALC_MMEE}
  setlength(mmee_PrecioSpot, 0);
  setlength(mmee_SeguimientoDeLaDemanda_USD, 0);
  {$ENDIF}

  ActualizadorLPD.Free;
  if FechaInicioDelpaso <> nil then
    FechaInicioDelPaso.Free;
  if FechaFinDelPaso <> nil then
    FechaFinDelPaso.Free;

  if CF <> nil then
    CF.Free;

  if liberarAuxs then
  begin
    for k := 0 to high(Auxs_r0) do
    begin
      setlength(Auxs_r0[k], 0);
      setlength(Auxs_r1[k], 0);
    end;
    setlength(Auxs_r0, 0);
    setlength(Auxs_r1, 0);

    for k := 0 to high(Auxs_i0) do
    begin
      setlength(Auxs_i0[k], 0);
      setlength(Auxs_i1[k], 0);
    end;
    setlength(Auxs_i0, 0);
    setlength(Auxs_i1, 0);
  end;


  {$IFDEF CALC_DEMANDA_NETA}
  setlength(Suma_PHorarias, 0);
  setlength(idxHorasPostizadas, 0);
  setlength(kBasePosete_idxHorasPostizadas, 0);
  setlength(NHorasDelPoste, 0);
  {$ENDIF}


  //{$IFDEF DBG}
  //  CloseFile(fdbg);
  //{$ENDIF}
  inherited Free;
end;

procedure TGlobs.CambioFichaPD;
begin
  raise Exception.Create('Metodo abstracto cambioFichaPD en ' + self.ClassName);
end;

procedure TGlobs.PubliVars;
begin
  inherited PubliVars;
  PublicarVariableFecha('FechaInicioDelPaso', FechaInicioDelPaso);
  PublicarVariableFecha('FechaFinDelPaso', FechaFinDelPaso);
  PublicarVariableNI('kPaso', '-', kPaso_);
  PublicarVariableNI('kCronica', '-', kCronica);
end;

{$IFDEF MIGRACION_PERSISTENCIA}
class function TGlobs.CreateDataConversionList: TListDataConversion;
begin
  Result := inherited CreateDataConversionList;
  Result.Add(87,
    ['ObligarDisponibilidad_1'],
    ['ObligarDisponibilidad_1_Sim'],
    Result.ConversionNAMECHANGE);
end;

class function TGlobs.CreateDataColumnList(xClaseDeCosa: TClaseDeCosa;
  xVersion: integer): TDataColumnListOfCosa;
begin
  Result := inherited CreateDataColumnList(xClaseDeCosa, xVersion);
  Result.AddBooleanColumn('Calcular_EmisionesCO2', False, 63);
  Result.AddDoubleColumn('CAR', 0.0, 59);
  Result.AddBooleanColumn('CAR_CVaR', True, 97);
  Result.AddBooleanColumn('Deterministico', False, 88);
  Result.AddIntegerColumn('NPostes', 0);
  Result.AddDAOfDoubleColumn('DurPos');
  Result.AddDoubleColumn('DurPaso_minutos', 10.0, 104);
  Result.AddIntegerColumn('FactorEmisiones_MargenOperativoTipo', 0, 68);
  Result.AddBooleanColumn('FactorEmisiones_ProyectoEolicoSolar', True, 68);
  Result.AddDateColumn('fechaFinOpt', 0);
  Result.AddDateColumn('fechaFinSim', 0);
  Result.AddDateColumn('fechaGuardaSim', 0, 102);
  Result.AddDateColumn('fechaIniOpt', 0);
  Result.AddDateColumn('fechaIniSim', 0);
  Result.AddStringColumn('iteracion_flucar_Archivo_Flucar', '', 74);
  Result.AddBooleanColumn('iteracion_flucar_modificar_peaje', False, 74);
  Result.AddBooleanColumn('iteracion_flucar_modificar_rendimiento', False, 74);
  Result.AddBooleanColumn('iteracion_flucar_modificar_capacidad', True, 74);
  Result.AddIntegerColumn('NCronicasOpt', 0);
  Result.AddIntegerColumn('NCronicasSim', 0);
  Result.AddIntegerColumn('NDiscHistoCF', 0, 59);
  Result.AddBooleanColumn('flg_ReservaRotante', False, 130);
  Result.AddIntegerColumn('NMAX_ITERACIONESDELPASO_OPT', 0);
  Result.AddIntegerColumn('NMAX_ITERACIONESDELPASO_SIM', 4);
  Result.AddBooleanColumn('ObligarDisponibilidad_1', False, 0, 87);
  Result.AddBooleanColumn('ObligarDisponibilidad_1_Opt', False, 87);
  Result.AddBooleanColumn('ObligarDisponibilidad_1_Sim', False, 87);
  Result.AddBooleanColumn('ObligarInicioCronicaIncierto_1_Sim', False, 101);
  Result.AddBooleanColumn('PostesMonotonos', True);
  Result.AddDoubleColumn('probLimiteRiesgo', 0.0, 59);
  Result.AddBooleanColumn('publicarSoloVariablesUsadasEnSimRes3', False, 109);
  Result.AddBooleanColumn('restarUtilidadesDelCostoFuturo', False, 84);
  Result.AddBooleanColumn('SalaMinutal', False, 104);
  Result.AddIntegerColumn('semilla_inicial_opt', 31, 99);
  Result.AddIntegerColumn('semilla_inicial_sim', 31, 99);
  Result.AddBooleanColumn('SortearOpt', True);
  Result.AddDoubleColumn('TasaDeActualizacion', 0.0);
  Result.AddBooleanColumn('usar_CAR', False, 60);

  Result.ValidationList.Add(TValidation.Create(
    TOperator.LESS_OR_EQUAL, 'fechaIniOpt', 'fechaIniSim',
    'El valor de fechaIniOpt debe ser menor o igual al de fechaIniSim.'));
  Result.ValidationList.Add(TValidation.Create(
    TOperator.LESS_OR_EQUAL, 'fechaIniSim', 'fechaFinSim',
    'El valor de fechaIniSim debe ser menor o igual al de fechaFinSim.'));
  Result.ValidationList.Add(TValidation.Create(
    TOperator.LESS_OR_EQUAL, 'fechaFinSim', 'fechaFinOpt',
    'El valor de fechaFinSim debe ser menor o igual al de fechaFinOpt.'));

  Result.ValidationList.Add(TValidation.Create(
    TOperator.REGEX, 'EtAct', '^[0-9]+\d{0,9999}$',
    'El valor para el campo EtAct debe estar entre 0 y 9999.'));
  Result.ValidationList.Add(TValidation.Create(
    TOperator.REGEX, 'NMAX_ITERACIONESDELPASO_OPT', '^[0-9]+\d{0,9999}$',
    'El valor para el campo NMAX_ITERACIONESDELPASO_OPT debe estar entre 0 y 9999.'));
  Result.ValidationList.Add(TValidation.Create(
    TOperator.REGEX, 'NMAX_ITERACIONESDELPASO_SIM', '^[0-9]+\d{0,9999}$',
    'El valor para el campo NMAX_ITERACIONESDELPASO_SIM debe estar entre 0 y 9999.'));

  Result.ValidationList.Add(TValidation.Create(
    TOperator.REGEX, 'NPostes', '^[1-9]+\d{1,9999}$',
    'El valor para el campo NPostes debe estar entre 1 y 9999.'));
  Result.ValidationList.Add(TValidation.Create(
    TOperator.REGEX, 'NCronicasOpt', '^[1-9]+\d{1,9999}$',
    'El valor para el campo ENCronicasOpt debe estar entre 1 y 9999.'));
  Result.ValidationList.Add(TValidation.Create(
    TOperator.REGEX, 'NCronicasSim', '^[1-9]+\d{1,9999}$',
    'El valor para el campo ENCronicasSim debe estar entre 1 y 9999.'));

end;

{$ENDIF}

procedure TGlobs.AfterInstantiation;
var
  i: integer;
begin
  inherited AfterInstantiation;
  {$IFDEF CALC_DEMANDA_NETA}
  setlength(Suma_PHorarias, 0);
  setlength(idxHorasPostizadas, 0);
  setlength(kBasePosete_idxHorasPostizadas, 0);
  setlength(NHorasDelPoste, 0);
  {$ENDIF}
  EscenarioActivo := nil;
  {$IFDEF PDE_RIESGO}
  setlength(HistoCF0, 0);
  setlength(HistoCF1_, 0);
  setlength(HistoCF1_s, 0);
  {$ENDIF}
  procAlertaHabilitado := False;
  calcularConstantesBasicasDelPaso;

  setLength(kPosteHorasDelPaso, ceil(HorasDelPaso));
  demandaPrincipal := nil;
  {$IFDEF CALC_MMEE}
  mmee_TopeDelSpot := 250.0; // ojo esto es para sobreescribir al leer
  setlength(mmee_PrecioSpot, NPostes);
  setlength(mmee_SeguimientoDeLaDemanda_USD, NPostes);
  {$ENDIF}
  SetLength(invDurPos, length(DurPos));

  for i := 0 to high(DurPos) do
    invDurPos[i] := 1 / durPos[i];

  SetLength(invDurPos, length(DurPos));

  for i := 0 to high(DurPos) do
    invDurPos[i] := 1 / durPos[i];

  invHorasDelPaso := 1 / HorasDelPaso;
  SegundosDelPaso := trunc(HorasDelPaso * 3600 + 0.1);
  invSegundosDelPaso := 1 / SegundosDelPaso;
  EstadoDeLaSala := CES_SIN_PREPARAR;
  ActualizadorLPD := TActualizadorFichasLPD.Create;
  FechaInicioDelpaso := TFecha.Create_Clone(fechaIniOpt);
  FechaFinDelPaso := TFecha.Create_OffsetHoras(FechaInicioDelpaso, HorasDelPaso);
  CF := nil;
  clearProcNots;
  MadresUniformes := TMadresUniformes.Create(10000);
  Fijar_kPaso(1); // solo para que inicialmente est algo definido

end;

function TGlobs.Validate: boolean;
var
  isValid: boolean;
begin
  isValid := False;

  // fIniOpt <= fIniSim <= fFinSim <= fFinOpt
  if (self.FechaIniOpt.dt <= self.FechaIniSim.dt) and
    (self.FechaIniSim.dt <= self.FechaFinSim.dt) and
    (self.FechaFinSim.dt <= self.FechaFinOpt.dt) then
    isValid := True;

  Result := (inherited Validate) and isValid;
end;


procedure AlInicio;
begin
  registrarClaseDeCosa(TGlobs.ClassName, TGlobs);
end;

procedure AlFinal;
begin
end;

end.
